;---------------------- filename: nu32polar.pro --------------------------------
; This file is called by                 | Compile nu32polar.pro & save as *.cpr
; nu32polarplot.html in same directory   | WAVE> .run, nu32polar 
; This file is located at                | WAVE> compile, 'nu32polar' 
; ~rkriz/public_html/crcd/modules/module01 The compile creates nu32polar.cpr
;-------------------------------------------------------------------------------
; !! NOTE: file nu32polar.cpr must be located at ~rkriz/public_html/crcd/bin !!
;-------------------------------------------------------------------------------
 function NU32POLAR, client_data;!! JWave UNCOMMENT !! 
;                                !! JWave UNCOMMENT !! p-array elements below
  p=fltarr(10)
  p(0) = getParam(client_data, 'em',   /Value, Default = +0.528E+10)
  p(1) = getParam(client_data, 'num',  /Value, Default = +0.354)
  p(2) = getParam(client_data, 'efl',  /Value, Default = +0.232E+12)
  p(3) = getParam(client_data, 'eft',  /Value, Default = +0.150E+11)
  p(4) = getParam(client_data, 'gflt', /Value, Default = +0.240E+11)
  p(5) = getParam(client_data, 'gftt', /Value, Default = +0.502E+10)
  p(6) = getParam(client_data, 'kftt', /Value, Default = +0.150E+11)
  p(7) = getParam(client_data, 'vf1',  /Value, Default = +0.00)
  p(8) = getParam(client_data, 'vf2',  /Value, Default = +0.60)
  p(9) = getParam(client_data, 'vf3',  /Value, Default = +1.00)
;
;  !! VERY IMPORTANT --->  !! JWave UNCOMMENT !! return,0 at end of this file
;-------------------------------------------------------------------------------
;
; pro nu32polar ; !! PV-Wave UNCOMMENT !! 
;    
; !! PV-Wave UNCOMMENT !!  p-array sample data set below 
;
; p=[+0.528E+10,   +0.354,$
;    +0.23200E+12, +0.15000E+11,$
;    +0.24000E+11, +0.50200E+10,$
;    +0.15000E+11,$
;    +0.00, +0.60, +1.00]
;
; Ten array elements defined 
;  p(0)=em,   p(1)=num,           Matrix isotropic elastic properties
;  p(2)=efl,  p(3)=eft,           Fiber Young's Moduli
;  p(4)=gflt, p(5)=gftt,          Fiber Shear Moduli
;  p(6)=kftt,                     Fiber Bulk Modulus
;  p(7)=vf1, p(8)=vf2, p(9)=vf3,  Three Fiber Volume Fractions 
;-------------------------------------------------------------------------------
; Write p-array into polar.DAT file so that the polar.DAT can be read by polar.f 
;
  openw,1,'/export/home/rkriz/public_html/crcd/modules/module01/polar.DAT'
  printf,1,Format='(e10.3)',p(0) & printf,1,Format='(f6.3)', p(1)   
  printf,1,Format='(e10.3)',p(2) & printf,1,Format='(e10.3)',p(3)   
  printf,1,Format='(e10.3)',p(4) & printf,1,Format='(e10.3)',p(5)   
  printf,1,Format='(e10.3)',p(6) & printf,1,Format='(f6.3)', p(7)   
  printf,1,Format='(f6.3)', p(8) & printf,1,Format='(f6.3)', p(9)   
  close,1
;
;------------- Spawn the Unix commands to execute polar.x ---------------
;  This is done with a shell script polar.sh that sets up necessary paths
;  and environmental variables to execute polar.x within the JWave app
;     - polar.x reads in p-array from file polar.DAT
;     - calculates composite elastic properties
;     - creates creates nu32.dat used below by nu32.pro
;
  spawn,'/export/home/rkriz/public_html/crcd/modules/module01/polar.sh'
;
;---- Above this line is additional code needed to interface with JWave app ----
;-------------------------------------------------------------------------------
;------- Below this line is the legacy PV-Wave code previously written ---------
;-------------------------- ORIGINAL: nu32.pro ---------------------------------
;
;  Plot of Poisson's ratio in X2-X3 plane of a unidirectional
;  composite material for three different fiber volume fractions.
;  Data calculated by polar.x (Ron Kriz 7-23-00 Virginia Tech
;
; pro nu32 ; uncomment only when running as the ORIGINAL nu32.pro 
;
;  Plot and Store legend of lines for different Fiber Volume Fractions
;
  openw,2,'/export/home/rkriz/public_html/crcd/modules/module01/nu32legend.byt'
  leg=assoc(2,bytarr(180,75))
;
  openr,3,'/export/home/rkriz/public_html/crcd/modules/module01/vf.dat' 
  readf,3,vf1,vf2,vf3
  a=intarr(5) & b=intarr(5) & c=intarr(5) & d=intarr(5)
  e=intarr(5) & f=intarr(5) & g=intarr(5)
;
  for i=1,5 do begin
    a(i-1)=20.0*i+30.0
    b(i-1)=13.0 & c(i-1)=27.0 & d(i-1)=41.0
    e(i-1)=9.0  & f(i-1)=23.0 & g(i-1)=37.0
  endfor
;
  !X.Style=4 & !Y.Style=4 & TEK_COLOR
; openzbuff,480,560      ; comment when attached to JWave function NU32POLAR !!!
  plot,a,d,xrange=[20,460],yrange=[0,410], $
         Position=[0.0,0.0,1.0,1.0], Color=8
  oplot,a,g,Color=7
  oplot,a,c,Color=5 & oplot,a,f,Color=3
  oplot,a,b,Color=2 & oplot,a,e,Color=6
  f1=string(format='(f4.2)',vf1) & f2=string(format='(f4.2)',vf2)
  f3=string(format='(f4.2)',vf3)
  xyouts, 134, 12, '+', size=0.8 & xyouts, 134,  7, '-', size=0.8
  xyouts, 134, 26, '+', size=0.8 & xyouts, 134, 21, '-', size=0.8
  xyouts, 134, 40, '+', size=0.8 & xyouts, 134, 35, '-', size=0.8
  xyouts, 155, 10, '['+f3+']', size=1.3
  xyouts, 155, 24, '['+f2+']', size=1.3
  xyouts, 155, 38, '['+f1+']', size=1.3
  xyouts,  41, 50, 'Fiber Volume Fraction, V!Bf!N', size=1.4
  leg(0)=tvrd(40,0,180,75)
; closezbuff,'nu32legend.jpg';comment when attached to JWave function NU32POLAR!
; Close z-buffer and create "jpeg" image
  close,2 & close,3
;
;  Plot Poisson's Ratio, nu32, polar diagram
;
  t=fltarr(6) & tr=fltarr(5) & r=fltarr(5)
  pi=acos(-1.)
;               Read in legend
    openr,4,'/export/home/rkriz/public_html/crcd/modules/module01/nu32legend.byt'
    leg=bytarr(180,75)
    readu,4,leg
;
; Read in data and assign data to appropriate arrays
  status= $
  DC_READ_FIXED('/export/home/rkriz/public_html/crcd/modules/module01/nu32.dat',$
                                                 rows,Format='(E11.4)',/Column)
  numr=size(rows)
  numberr=numr(1)
  openr,5,'/export/home/rkriz/public_html/crcd/modules/module01/nu32.dat'
  data=fltarr(numberr)
  datb=fltarr(numberr) & datc=fltarr(numberr) & datd=fltarr(numberr)
  date=fltarr(numberr) & datf=fltarr(numberr) & datg=fltarr(numberr)
  for i=1,numberr do begin
    readf,5,dataa,datbb,datcc,datdd,datee,datff,datgg
    data(i-1)=dataa
    datb(i-1)=datbb & datc(i-1)=datcc & datd(i-1)=datdd
    date(i-1)=datee & datf(i-1)=datff & datg(i-1)=datgg
  endfor
;
; Determine maximum radius for polar plot
  t(0)=MAX(datb) & t(1)=MAX(datc) & t(2)=MAX(datd)
  t(3)=MAX(-date) & t(4)=MAX(-datf) & t(5)=MAX(-datg) & rmax=MAX(t) & print,rmax
;
; Create five point array that forces polar plot to use equally scaled axes
  tr(0)=0.0 & tr(1)=pi/2 & tr(2)=pi & tr(3)=3*pi/2 & tr(4)=2*pi &  r(*)=rmax
;
; Set parameters for plotting six functions 
  TEK_COLOR
; openzbuff,480,560      ; comment when attached to JWave function NU32POLAR !!!
  !P.Font=0 & !P.Charsize=2.0
  !X.Minor=-1 & !Y.Minor=-1 & !X.Ticks=2 & !Y.Ticks=2
  !Y.Margin=[4,4] & !X.Margin=[4,4]
  !X.Style=1 & !Y.Style=1
  plot, /Polar, XStyle=4, YStyle=4, r, tr, Color=0 ; HIDDEN PLOT SCALES AXES SAME
  AXIS, XAxis = 0, 0, 0, XRange=[-rmax,+rmax], /Save, /Data
  AXIS, YAxis = 0, 0, 0, YRange=[-rmax,+rmax], /Save, /Data
  XYOUTS, 55, 530, /DEVICE, 'Poissons Ratio in X!B2!N-X!B3!N Plane, Nu!B2!B3'
  XYOUTS, 255, 490, /DEVICE, 'X!B2' & XYOUTS, 435, 295, /DEVICE, 'X!B3'
  oplot,/Polar,datd,data,Color=2 & oplot,/Polar,datg,data,Color=6
  oplot,/Polar,datc,data,Color=5 & oplot,/Polar,datf,data,Color=3
  oplot,/Polar,datb,data,Color=8 & oplot,/Polar,date,data,Color=7
  tv,leg,280,0
; closezbuff,'nu32.jpg'  ; comment when attached to JWave function NU32POLAR !!!
; Close z-buffer and create "jpeg" image
;
  close,4 & close,5   ; !!!! JWave UNCOMMENT spawn command below !!!!
  spawn,'/export/home/rkriz/public_html/crcd/modules/module01/cleanup.sh'
;-------------------------------------------------------------------------------
  return,0  ; !! JWave UNCOMMENT !!
  end
