 pro pltgrd
;
;  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;  *  PROGRAM PLTGRD:  PLOTS GRID THAT IS CONSTRUCTED ONLY OF          *
;  *  TRIANGULAR ELEMENTS. GRID IS SAVED AS A "GIF" IMAGE.             *
;  *  COORDINATES OF THE ORIGIN OR THE FIRST NODE POINT IS             *
;  *  ASSUMED TO BE LOCATED IN THE LOWER LEFT-HAND-CORNER OF THE       *
;  *  GRID. WRITTEN BY R.D.KRIZ, SUMMER 2000. BLACKSBURG, VIRGINIA     *
;  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;
;openr,5,'w45090m.dat' 
 openr,5,'l090ncm.dat' 
 f=string('') 
 hi=fltarr(1286) & zi=fltarr(1286)
 n1=intarr(2394) & n2=intarr(2394) & n3=intarr(2394)
;
;   READ FIRST LINE OF INPUT FOR GRID INFO.
;      NODES , NUMBER OF NODES
;      NELEM , NUMBER OF ELEMENTS
 readf,5,format='(2I6)',nelem,nodes
 nodes=fix(nodes)
 nelem=fix(nelem)
 nodesm1=nodes-1
 nelemm1=nelem-1
; 
; Skip 16 for nonwoven grid or 22 lines for woven grid
 for is=0,15 do begin
;for is=0,21 do begin
  readf,5,f
 endfor
;
;  Define mins and maxs for X and Y coordinates
 min_y=-0.6 & max_y=12.5
 min_x=-0.5 & max_x=16.5
;
; Set X and Y data Scales as PV-Wave system variables
 !X.S = [-min_x, 1.]/(max_x-min_x)
 !Y.S = [-min_y, 1.]/(max_y-min_y)
;
;        READ NODE POINT COORDINATES
 for ind=0,nodesm1 do begin
   readf,5,format='(15x,2F12.5)',h,z
   hi(ind)=h & zi(ind)=z
 endfor
;
;      READ ELEMENT AND ASSOCIATED NODE NO. TOPOLOGY
 for iel=0,nelemm1 do begin
   readf,5,format='(6x,3I6)',a,b,c
   n1(iel)=a & n2(iel)=b & n3(iel)=c
 endfor
;
 !P.BACKGROUND=255 & TEK_COLOR
;
;  Setup Z buffer for "gif" image grid plot 
 set_plot,'pm' & openzbuff,800,650
;
;     Setup Window for plotting grid
;window,1,xsize=800,ysize=650,xpos=200,ypos=600
; 
;                  PLOT ELEMENTS 
 for ie=0,nelemm1 do begin
   plots,[hi(n1(ie)-1),hi(n2(ie)-1)],[zi(n1(ie)-1),zi(n2(ie)-1)],color=0
   plots,[hi(n2(ie)-1),hi(n3(ie)-1)],[zi(n2(ie)-1),zi(n3(ie)-1)],color=0
   plots,[hi(n3(ie)-1),hi(n1(ie)-1)],[zi(n3(ie)-1),zi(n1(ie)-1)],color=0
 endfor
;
 closezbuff,'nonwovengrid.gif'
;
 close,5
 end 
