      PROGRAM TPLGY
C
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C  *  PROGRAM TOPLGY: CALCULATES NODE NO.S ASSOCIATED WITH EACH ELEMENT  *
C  *  FOR A GRID WITH AND WITHOUT REPEATING BLOCKS                       *
C  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C      GRID DATA WITHOUT REPEATING BLOCKS ON FILENAME "TOPLGYD"
C      NODE NUMBERS STORED ON FILE "TOPLGYD" SEQUENTIALLY STARTING
C      AT ELEMENT NO. 1 TO ELEMENT NO. NAME "NEL" IN COMPACT FORM
C      AND ARE SORTED AND REWRITTEN ON OUTPUT FILE "TOPLGYL" WITH
C      PROPER FORMAT FOR FINITE ELEMENT PROGRAM "LFEMID" INPUT FILE
C
      DIMENSION N1(6),N2(6),N3(6)
      OPEN(5,FILE='l090tplgy.dat',STATUS='OLD',ERR=888)
      OPEN(6,FILE='l090tplgy.out',STATUS='UNKNOWN',ERR=888)
      READ(5,4)NGRPS
    4 FORMAT(I2)
      IF(NGRPS.EQ.0)GO TO 3333
      II=1
      DO 501 IGRP=1,NGRPS
      READ(5,5)NEL,ANG,ITYPE
    5 FORMAT(I4,F6.1,I3)
      DO 500 I=1,NEL,6
      READ(5,10)NS,(N1(IS),N2(IS),N3(IS),IS=1,NS)
   10 FORMAT(I1,18(1X,I3))
      DO 50 IS=1,NS
      I1=N1(IS)
      I2=N2(IS)
      I3=N3(IS)
      WRITE(6,6)II,I1,I2,I3,ANG,ITYPE
    6 FORMAT(4I6,F8.2,I3)
      II=II+1
   50 CONTINUE
  500 CONTINUE
  501 CONTINUE
C
C********************************************************************
C
C      OUTPUT FORMAT
C
   99 FORMAT(4I6,F8.2,I3)
C
C********************************************************************
C
C         GRID FAR FROM PLY CRACK; NODE NO.S ASSOCIATED WITH ELEMENTS
C
C     READ NO. OF SECTIONS
C
 3333 READ(5,11)NSECT
   11 FORMAT(I1)
      IF(NSECT.EQ.0)STOP
C
C        LOOP THRU NSECT SECTIONS
C
      DO 1100 ISECT=1,NSECT
C
C        READ NO. OF LAYERS,VERTICAL BLOCKS,AND STARTING ELEMENT NO.
C
      READ(5,12)NLAY,NB,IEL
   12 FORMAT(I1,1X,I2,1X,I4)
C
C        DOUBLE THE NO. OF VERTICAL BLOCKS
C
      NB2=NB*2
C
C       FORMAT STATEMENTS USED IN LAYER LOOP
C
   13 FORMAT(F5.1,I3,/,I4)
   14 FORMAT(I4,/,I4)
   15 FORMAT(I4)
C
C          LOOP THRU NLAY LAYERS
C
C
      DO 1000 ILAY=1,NLAY
C
C           READ FIBER ORIENTATION AND FIRST NODE NO.
C
      READ(5,13)ANG,ITYPE,ITOP
C
C
C**********************************************************************
C
C    FIRST GROUP TYPE
C
      READ(5,14)IMID,IBTM
      IBTMS=IBTM
C
C     NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 101 IB=1,NB2
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C
      IN11=IMID
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IMID
      IN22=IBTM
      IN32=ITOP
C
      IN13=IMID
      IN23=IBTM+1
      IN33=IBTM
C
      IN14=IMID
      IN24=ITOP+1
      IN34=IBTM+1
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      IMID=IMID+1
      ITOP=ITOP+1
      IBTM=IBTM+1
C
  101 CONTINUE
C
C**********************************************************************
C
C      SECOND GROUP TYPE
C
      ITOP=IBTMS
      READ(5,15)IBTM
      IBTMS=IBTM
C
C       NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 102 IB=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C
      IN11=IBTM
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IBTM
      IN22=ITOP+1
      IN32=IBTM+1
C
      IN13=IBTM+1
      IN23=ITOP+1
      IN33=IBTM+2
C
      IN14=ITOP+1
      IN24=ITOP+2
      IN34=IBTM+2
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      ITOP=ITOP+2
      IBTM=IBTM+2
C
  102 CONTINUE
C
C**********************************************************************
C
C          THIRD GROUP TYPE
C
      ITOP=IBTMS
      READ(5,14)IMID,IBTM
      IBTMS=IBTM
C
C   NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 106 ID=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
      IE5=IEL+4
      IE6=IEL+5
      IE7=IEL+6
C
      IN11=IMID+1
      IN21=ITOP+1
      IN31=ITOP+2
C
      IN12=IMID+1
      IN22=ITOP
      IN32=ITOP+1
C
      IN13=IMID+1
      IN23=IMID
      IN33=ITOP
C
      IN14=IMID+1
      IN24=IBTM
      IN34=IMID
C
      IN15=IMID+1
      IN25=IBTM+1
      IN35=IBTM
C
      IN16=IMID+1
      IN26=IMID+2
      IN36=IBTM+1
C
      IN17=IMID+1
      IN27=ITOP+2
      IN37=IMID+2
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
      WRITE(6,99)IE5,IN15,IN25,IN35,ANG,ITYPE
      WRITE(6,99)IE6,IN16,IN26,IN36,ANG,ITYPE
      WRITE(6,99)IE7,IN17,IN27,IN37,ANG,ITYPE
C
      IEL=IEL+7
      IMID=IMID+2
      ITOP=ITOP+2
      IBTM=IBTM+1
C
  106 CONTINUE
C
C************************************************************************
C
C
C     FOURTH GROUP TYPE
C
      ITOP=IBTMS
      READ(5,14)IMID,IBTM
      IBTMS=IBTM
C
C  NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 111 IB=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C
      IN11=IMID
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IMID
      IN22=IBTM
      IN32=ITOP
C
      IN13=IMID
      IN23=IBTM+1
      IN33=IBTM
C
      IN14=IMID
      IN24=ITOP+1
      IN34=IBTM+1
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      IMID=IMID+1
      ITOP=ITOP+1
      IBTM=IBTM+1
C
  111 CONTINUE
C
C************************************************************************
C
C
C     FOURTH GROUP TYPE
C
      ITOP=IBTMS
      READ(5,14)IMID,IBTM
      IBTMS=IBTM
C
C  NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 112 IB=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C
      IN11=IMID
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IMID
      IN22=IBTM
      IN32=ITOP
C
      IN13=IMID
      IN23=IBTM+1
      IN33=IBTM
C
      IN14=IMID
      IN24=ITOP+1
      IN34=IBTM+1
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      IMID=IMID+1
      ITOP=ITOP+1
      IBTM=IBTM+1
C
  112 CONTINUE
C
C***********************************************************************
C
C
C          FIFTH GROUP TYPE
C
      ITOP=IBTMS
      READ(5,14)IMID,IBTM
      IBTMS=IBTM
C
C   NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 116 ID=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
      IE5=IEL+4
      IE6=IEL+5
      IE7=IEL+6
C
      IN11=IMID+1
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IMID+1
      IN22=IMID
      IN32=ITOP
C
      IN13=IMID+1
      IN23=IBTM
      IN33=IMID
C
      IN14=IMID+1
      IN24=IBTM+1
      IN34=IBTM
C
      IN15=IMID+1
      IN25=IBTM+2
      IN35=IBTM+1
C
      IN16=IMID+1
      IN26=IMID+2
      IN36=IBTM+2
C
      IN17=IMID+1
      IN27=ITOP+1
      IN37=IMID+2
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
      WRITE(6,99)IE5,IN15,IN25,IN35,ANG,ITYPE    
      WRITE(6,99)IE6,IN16,IN26,IN36,ANG,ITYPE    
      WRITE(6,99)IE7,IN17,IN27,IN37,ANG,ITYPE    
C
      IEL=IEL+7
      IMID=IMID+2
      ITOP=ITOP+1
      IBTM=IBTM+2
C
C
C
  116 CONTINUE
C
C***********************************************************************
C
C          SIXTH GROUP TYPE
C
      ITOP=IBTMS
      READ(5,15)IBTM
      IBTMS=IBTM
C
C        NODE NO.S ASSOCIATED WITH ELEMENT NO. X
C
      DO 118 IB=1,NB
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C  
      IN11=IBTM
      IN21=ITOP
      IN31=IBTM+1
C
      IN12=ITOP
      IN22=ITOP+1
      IN32=IBTM+1
C
      IN13=ITOP+1
      IN23=ITOP+2
      IN33=IBTM+1
C
      IN14=IBTM+1
      IN24=ITOP+2
      IN34=IBTM+2
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      ITOP=ITOP+2
      IBTM=IBTM+2
C
  118 CONTINUE
C
C************************************************************************
C
C
C    FIRST GROUP TYPE
C
      ITOP=IBTMS
      READ(5,14)IMID,IBTM
C
C     NODE NO.S ASSOCIATED WITH ELEMENT NO.S
C
      DO 121 IB=1,NB2
C
      IE1=IEL
      IE2=IEL+1
      IE3=IEL+2
      IE4=IEL+3
C
      IN11=IMID
      IN21=ITOP
      IN31=ITOP+1
C
      IN12=IMID
      IN22=IBTM
      IN32=ITOP
C
      IN13=IMID
      IN23=IBTM+1
      IN33=IBTM
C
      IN14=IMID
      IN24=ITOP+1
      IN34=IBTM+1
C
      WRITE(6,99)IE1,IN11,IN21,IN31,ANG,ITYPE
      WRITE(6,99)IE2,IN12,IN22,IN32,ANG,ITYPE
      WRITE(6,99)IE3,IN13,IN23,IN33,ANG,ITYPE
      WRITE(6,99)IE4,IN14,IN24,IN34,ANG,ITYPE
C
      IEL=IEL+4
      IMID=IMID+1
      ITOP=ITOP+1
      IBTM=IBTM+1
C
  121 CONTINUE
C
C************************************************************************
C
C
C       END OF GROUPS
C
 1000 CONTINUE
C
C     END OF LOOP ON LAYERS
C
 1100 CONTINUE
C
C      END OF LOOP ON SECTIONS
C
      STOP
  888 END
