      PROGRAM SGRID

C

C * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

C *  PROGRAM SGRID: CALCULATES GRID TOPOLOGY FOR A RECTANGULAR GRID   *

C *  AFTER BENZLEY WITH CRACK TIP SINGULAR ELEMENTS. R.D.KRIZ 7/29/86 *

C * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

C

      DIMENSION H(140),Z(140),ND1(120),ND2(120),ND3(120),ND4(120)

      REAL*8 PI,DELH,DELZ1,DELZ2,H,Z

C

      OPEN(6,FILE='SGRID.OUT',STATUS='UNKNOWN',ERR=888)

C

C  CALCULATE NODE POINT COORDINATES

C

C       INITIALIZE PARAMETERS

C

      IND=1

      PI=3.1415927

      IND=1

      DELH=PI/10.0

      DELZ1=PI/5.0

      DELZ2=PI/10.0

      Z(IND)=2.0*PI

      H(IND)=0.0

C

      DO 100 IZ=1,12

      DO 100 IH=1,11

      IND=IND+1

      IF(IND.GE.133)GO TO 100

      H(IND)=H(IND-1)+DELH

      IF(IH.EQ.11)H(IND)=0.0

      Z(IND)=Z(IND-1)

      IF((IH.EQ.11).AND.(IZ.LE.9))Z(IND)=Z(IND-1)-DELZ1

      IF((IH.EQ.11).AND.(IZ.GT.9))Z(IND)=Z(IND-1)-DELZ2

  100 CONTINUE

C

C  CALCULATE NODE POINTS ASSOCIATED WITH ELEMENTS

C

C      INITIALIZE PARAMETERS

C

      K=1

      ND1(K)=12

      ND2(K)=13

      ND3(K)=2

      ND4(K)=1

C

      DO 200 J=1,11

      DO 200 I=1,10

      K=K+1

      IF(K.GT.111)GO TO 200

      ND1(K)=ND1(K-1)+1

      ND2(K)=ND2(K-1)+1

      ND3(K)=ND3(K-1)+1

      ND4(K)=ND4(K-1)+1

      IF(I.LT.10)GO TO 200

      ND1(K)=ND1(K-1)+2

      ND2(K)=ND2(K-1)+2

      ND3(K)=ND3(K-1)+2

      ND4(K)=ND4(K-1)+2

  200 CONTINUE

C

C          CALCULATE NODE POINT CONSTRAINTS AND

C  WRITE RESULTS TO OUTPUT FILE UNIT-6 IN THE SAME FORMAT

C         USED BY THE FINITE ELEMENT PROGRAM SFEM

C

      DO 300 IND=1,132

      IDH=0

      IDZ=0

      IF(H(IND).EQ.0.0)IDH=1

      IF((Z(IND).LT.0.00000001).AND.(IND.GE.127))IDZ=1

  300 WRITE(6,350)IND,IDH,IDZ,H(IND),Z(IND)

  350 FORMAT(1X,I6,2I3,2F12.9)

      KTYPE=1

      MGRAD=0

      THIC=1.0

      DO 400 K=1,110

  400 WRITE(6,450)K,ND1(K),ND2(K),ND3(K),ND4(K),KTYPE,MGRAD,THIC

  450 FORMAT(1X,7I6,F12.1)

  888 STOP

      END

 K=1,110

  400 WRITE(6,450)K,ND1(K),ND2(K),ND3(K),ND4(K),KTYPE,MGRAD,THIC

  450 FORMAT(1X,7I6,F12.1